> For the complete documentation index, see [llms.txt](https://docs.hypertensor.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hypertensor.org/network/subnet-node/staking.md).

# Staking

All staking functionality must be called by the coldkey of the subnet node.

## Add To Stake

```rust
pub fn add_to_stake(
    origin: OriginFor<T>, 
    subnet_id: u32,
    subnet_node_id: u32,
    hotkey: T::AccountId,
    stake_to_be_added: u128,
)
```

## Remove Stake

When removing stake, the balance removed is put into the unbonding ledger for the length of the stake cooldown epochs. After the balance can then be claimed by calling `claim_unbondings`.

Nodes can remove their stake balance up to the minimum required stake balance for the subnet. If the caller is no longer a node in the subnet, it can remove the full balance.

```rust
pub fn remove_stake(
    origin: OriginFor<T>, 
    subnet_id: u32, 
    hotkey: T::AccountId,
    stake_to_be_removed: u128
)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hypertensor.org/network/subnet-node/staking.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
